/* Author : Dario GENGA
 * Date : 18.01.2022
 * Description : Hash library.
 */

#ifndef _HASHTABLE_H
#define _HASHTABLE_H
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>

typedef struct hm_t {
    struct entry_t **entries;
    int length;
} hm;

typedef struct entry_t {
    char *key;
    char *value;
    struct entry_t *next;
} entry;

// création d'un pointeur vers une hm
hm *hm_create(unsigned int length);
// destruction de la hm et libération de la mémoire
void hm_destroy(hm **hm);
// insère la paire key-value dans la hm. si key est déjà présente écraser value dans la hm.
hm *hm_set(hm *hm, const char *const key, const char *const value);
// retourne la valeur associé à la clé, key
char *hm_get(const hm *const hm, const char *const key);
// retire une clé de la hm et la retourne
char *hm_rm(hm *hm, const char *const key);
// convertit la hm en chaîne de caractères
char *hm_to_str(const hm *const hm);
// affiche le contenu de la hm
void hm_print(const hm *const hm);

#endif
