/* Author : Dario GENGA
 * Date : 18.01.2022
 * Description : Hash library.
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "hashtable.h"

int main() {
    srand(0);
    hm *hashmap = hm_create(5);

    while (true) {
        printf("Add (1), Delete (2), Search (3), Print (4), Exit (5)...\n");
        int selection;
        scanf("%d", &selection);
        if (selection < 1 || selection > 5) {
            printf("Bad input, try again.\n");
            continue;
        }
        char phone[10];
        char name[10];

        if (selection == 1) {
            printf("Phone :\n");
            scanf("%s", phone);
            printf("Name :\n");
            scanf("%s", name);
            char *p = strdup(phone);
            char *n = strdup(name);
            hm_set(hashmap, p, n);
            hm_print(hashmap);
            free(n);
            free(p);
        }
        if (selection == 2) {
            printf("Phone to delete :\n");
            scanf("%s", phone);
            hm_rm(hashmap, phone);
            hm_print(hashmap);
        }
        if (selection == 3) {
            printf("Phone to search :\n");
            scanf("%s", phone);
            char *p = strdup(phone);
            char *name = hm_get(hashmap, p);
            if (name != NULL) {
                printf("%s\n", name);
            }
        }
        if (selection == 4) {
            hm_print(hashmap);
        }
        if (selection == 5) {
            break;
        }
    }

    hm_destroy(&hashmap);

    return EXIT_SUCCESS;
}
